;-------------------------------------------------------------
;+
; NAME:
;       EDITCAT
; PURPOSE:
;       This routine creates a widget interface for editing an earthquake catalog
; MAIN PROGRAM:
;       SLAP - program for testing SEISMOLAP 
;       SEISMOLAP was developed by Jochen Zschau,
;       Geoforschungszentrum Potsdam, Germany
; DEPENDENCIES:
;       EDITIME.PRO
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TU-Darmstadt, Germany, 17 Apr, 1998.
;       No warranty that this program is free of error
;-
;-------------------------------------------------------------
FUNCTION EDITCAT, GROUP = Group,$
                  ALTERED = altered,$
                  QUAKE_JS = quake_js,$
                  QUAKE_LAT = quake_lat,$
                  QUAKE_LON = quake_lon, $
                  QUAKE_Z = quake_z, $
                  QUAKE_STRENGTH = quake_strength, $
                  QUAKE_QUALITY = quake_quality,$
                  QUAKE_N = quake_n


IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

junk   = { CW_PDMENU_S, flags:0, name:'' }


altered=0
altered_time=0

;init borders
lon_min = MIN ( quake_lon, MAX = lon_max )
lat_min = MIN ( quake_lat, MAX = lat_max )
z_min = MIN ( quake_z, MAX = z_max )
strength_min = MIN ( quake_strength, MAX = strength_max )
quality_min = MIN ( quake_quality, MAX = quality_max )
js_min = MIN ( quake_js, MAX = js_max )


  MAIN1 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Edit catalog', $
      UVALUE='MAIN1')

  BASE318 = WIDGET_BASE(MAIN1, $
      COLUMN=1, $
      FRAME=1, $
      MAP=1, $
      UVALUE='BASE318')

  LABEL307 = WIDGET_LABEL( BASE318, $
      UVALUE='LABEL307', $
      VALUE='Catalog values')

  BASE158 = WIDGET_BASE(BASE318, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE158')

  LABEL308 = WIDGET_LABEL( BASE158, $
      UVALUE='LABEL308', $
      VALUE='Longitude [deg]')

  FieldVal849 = [ $
    '' ]
  FIELD_LON_MIN = CW_FIELD( BASE158,VALUE=FieldVal849, $
      ROW=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='min', $
      UVALUE='FIELD_LON_MIN', $
      XSIZE=9)

  FieldVal851 = [ $
    '' ]
  FIELD_LON_MAX = CW_FIELD( BASE158,VALUE=FieldVal851, $
      ROW=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='max', $
      UVALUE='FIELD_LON_MAX', $
      XSIZE=9)


  BASE152 = WIDGET_BASE(BASE318, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE152')

  LABEL311 = WIDGET_LABEL( BASE152, $
      UVALUE='LABEL311', $
      VALUE='Latitude [deg] ..')

  FieldVal855 = [ $
    '' ]
  FIELD_LAT_MIN = CW_FIELD( BASE152,VALUE=FieldVal855, $
      ROW=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='min', $
      UVALUE='FIELD_LAT_MIN', $
      XSIZE=9)

  FieldVal857 = [ $
    ' ' ]
  FIELD_LAT_MAX = CW_FIELD( BASE152,VALUE=FieldVal857, $
      ROW=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='max', $
      UVALUE='FIELD_LAT_MAX', $
      XSIZE=9)


  BASE260 = WIDGET_BASE(BASE318, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE260')

  LABEL314 = WIDGET_LABEL( BASE260, $
      UVALUE='LABEL314', $
      VALUE='Depth [m]...')

  FieldVal861 = [ $
    '' ]
  FIELD_DEP_MIN = CW_FIELD( BASE260,VALUE=FieldVal861, $
      ROW=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='min', $
      UVALUE='FIELD_DEP_MIN', $
      XSIZE=9)

  FieldVal863 = [ $
    ' ' ]
  FIELD_DEP_MAX = CW_FIELD( BASE260,VALUE=FieldVal863, $
      ROW=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='max', $
      UVALUE='FIELD_DEP_MAX', $
      XSIZE=9)


  BASE326 = WIDGET_BASE(BASE318, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE326')

  LABEL323 = WIDGET_LABEL( BASE326, $
      UVALUE='LABEL323', $
      VALUE='Magnitude..')

  FieldVal3690 = [ $
    '' ]
  FIELD_MAG_MIN = CW_FIELD( BASE326,VALUE=FieldVal3690, $
      ROW=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='min', $
      UVALUE='FIELD_MAG_MIN', $
      XSIZE=9)

  FieldVal3692 = [ $
    ' ' ]
  FIELD_MAG_MAX = CW_FIELD( BASE326,VALUE=FieldVal3692, $
      ROW=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='max', $
      UVALUE='FIELD_MAG_MAX', $
      XSIZE=9)


  BASE334 = WIDGET_BASE(BASE318, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE334')

  LABEL331 = WIDGET_LABEL( BASE334, $
      UVALUE='LABEL331', $
      VALUE='Quality ......')

  FieldVal3696 = [ $
    '' ]
  FIELD_QUAL_MIN = CW_FIELD( BASE334,VALUE=FieldVal3696, $
      ROW=1, $
      LONG=1, $
      ALL_EVENTS=1, $
      TITLE='min', $
      UVALUE='FIELD_QUAL_MIN', $
      XSIZE=9)

  FieldVal3698 = [ $
    '' ]
  FIELD_QUAL_MAX = CW_FIELD( BASE334,VALUE=FieldVal3698, $
      ROW=1, $
      LONG=1, $
      ALL_EVENTS=1, $
      TITLE='max', $
      UVALUE='FIELD_QUAL_MAX', $
      XSIZE=9)



  LABEL354 = WIDGET_LABEL( BASE318, $
      UVALUE='LABEL354', $
      VALUE='')

  BUTTON_TIME_BORDER = WIDGET_BUTTON( BASE318, $
      UVALUE='BUTTON_TIME_BORDER', $
      VALUE='Time border')



  LABEL256 = WIDGET_LABEL( MAIN1, $
      UVALUE='LABEL256', $
      VALUE='')

  BUTTON37 = WIDGET_BUTTON( MAIN1, $
      UVALUE='BUTTON_CANCEL', $
      VALUE='Cancel')

  BUTTON40 = WIDGET_BUTTON( MAIN1, $
      UVALUE='BUTTON_OK', $
      VALUE='Ok')

  WIDGET_CONTROL, FIELD_LON_MIN, SET_VALUE = lon_min
  WIDGET_CONTROL, FIELD_LAT_MIN, SET_VALUE = lat_min
  WIDGET_CONTROL, FIELD_DEP_MIN, SET_VALUE = z_min
  WIDGET_CONTROL, FIELD_MAG_MIN, SET_VALUE = strength_min
  WIDGET_CONTROL, FIELD_QUAL_MIN, SET_VALUE = quality_min
  WIDGET_CONTROL, FIELD_LON_MAX, SET_VALUE = lon_max
  WIDGET_CONTROL, FIELD_LAT_MAX, SET_VALUE = lat_max
  WIDGET_CONTROL, FIELD_DEP_MAX, SET_VALUE = z_max
  WIDGET_CONTROL, FIELD_MAG_MAX, SET_VALUE = strength_max
  WIDGET_CONTROL, FIELD_QUAL_MAX, SET_VALUE = quality_max

  WIDGET_CONTROL, MAIN1, /REALIZE


Ev=''

WHILE (Ev NE 'BUTTON_OK') AND (Ev NE 'BUTTON_CANCEL') DO BEGIN

Event=WIDGET_EVENT(MAIN1)

WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

CASE Ev OF

  'FIELD_LON_MIN': BEGIN
      lon_min = DOUBLE(event.value)
      altered = 1
      END
  'FIELD_LON_MAX': BEGIN
      lon_max = DOUBLE(event.value)
      altered = 1
      END
  'FIELD_LAT_MIN': BEGIN
      lat_min = DOUBLE(event.value)
      altered = 1
      END
  'FIELD_LAT_MAX': BEGIN
      lat_max = DOUBLE(event.value)
      altered = 1
      END
  'FIELD_DEP_MIN': BEGIN
      z_min = DOUBLE(event.value)
      altered = 1
      END
  'FIELD_DEP_MAX': BEGIN
      z_max = DOUBLE(event.value)
      altered = 1
      END
  'FIELD_MAG_MIN': BEGIN
      strength_min = DOUBLE(event.value)
      altered = 1
      END
  'FIELD_MAG_MAX': BEGIN
      strength_max = DOUBLE(event.value)
      altered = 1
      END
  'FIELD_QUAL_MIN': BEGIN
      quality_min = event.value
      altered = 1
      END
  'FIELD_QUAL_MAX': BEGIN
      quality_max = event.value
      altered = 1
      END
  'BUTTON_TIME_BORDER': BEGIN
      EDITIME, ALTERED=altered_time,$
               QUAKE_JS=quake_js,$
               QUAKE_TIME_BORDER=quake_time_border

      END
  'BUTTON_CANCEL': BEGIN
      END
  'BUTTON_OK': BEGIN
      END

ENDCASE

ENDWHILE

IF Ev EQ 'BUTTON_OK' THEN BEGIN

create_structure:

   IF altered OR altered_time THEN BEGIN

      yn = XDECISION([['Events will be deleted!'],$
                      ['Do you want to continue ?']] )


      IF STRUPCASE(yn) EQ 'Y' THEN BEGIN

         delete = LONARR(quake_n) * 0L

         IF altered_time THEN BEGIN

            index = WHERE ( quake_js LT quake_time_border(0), count )
            IF count GT 0 THEN delete(index) = 1

            index = WHERE ( quake_js GT quake_time_border(1), count )
            IF count GT 0 THEN delete(index) = 1

         ENDIF

         index = WHERE ( quake_lon LT lon_min, count )
         IF count GT 0 THEN delete(index) = 1

         index = WHERE ( quake_lon GT lon_max, count )
         IF count GT 0 THEN delete(index) = 1

         index = WHERE ( quake_lat LT lat_min, count )
         IF count GT 0 THEN delete(index) = 1

         index = WHERE ( quake_lat GT lat_max, count )
         IF count GT 0 THEN delete(index) = 1

         index = WHERE ( quake_z LT z_min, count )
         IF count GT 0 THEN delete(index) = 1

         index = WHERE ( quake_z GT z_max, count )
         IF count GT 0 THEN delete(index) = 1

         index = WHERE ( quake_strength LT strength_min, count )
         IF count GT 0 THEN delete(index) = 1

         index = WHERE ( quake_strength GT strength_max, count )
         IF count GT 0 THEN delete(index) = 1

         index = WHERE ( quake_quality LT quality_min, count )
         IF count GT 0 THEN delete(index) = 1

         index = WHERE ( quake_quality GT quality_max, count )
         IF count GT 0 THEN delete(index) = 1

         index = WHERE (delete EQ 0)

         js = quake_js(index)
         lon = quake_lon(index)
         lat = quake_lat(index)
         z = quake_z(index)
         strength = quake_strength(index)
         quality = quake_quality(index)
         n = N_ELEMENTS(index)

         quake=CREATE_STRUCT ( $
                'js',TEMPORARY(js),$
                'lon',TEMPORARY(lon), $
                'lat',TEMPORARY(lat),$
                'z',TEMPORARY(z),$
                'strength',TEMPORARY(strength),$
                'quality',TEMPORARY(quality), $
                'n',n $
                )

      ENDIF ELSE  quake=0
   ENDIF ELSE  quake=0
ENDIF ELSE  quake=0


IF DEFINED(MAIN1) THEN WIDGET_CONTROL,MAIN1,/DESTROY
RETURN,TEMPORARY(quake)
END
