;------------------------------------------------------------- 
;+ 
; NAME: 
;       EDITIME 
; PURPOSE: 
;       This routine creates a widget based interface for editing minimum and 
;       maximum time of an earthquake - catalog 
; MAIN PROGRAM: 
;       SLAP - program for testing SEISMOLAP  
;       SEISMOLAP was developed by Jochen Zschau, 
;       Geoforschungszentrum Potsdam, Germany 
; DEPENDENCIES: 
;       JHUAPL IDL libraries, Dec 1996 - Johns Hopkins Applied Physics Laboratory 
; MODIFICATION HISTORY: 
;       Matthias Liebetanz, TU-Darmstadt, Germany, 17 Apr, 1998. 
;       No warranty that this program is free of error 
;- 
;------------------------------------------------------------- 
PRO EDITIME, GROUP=Group,$ 
             ALTERED=altered,$ 
             QUAKE_JS=quake_js,$ 
             QUAKE_TIME_BORDER=quake_time_border 
 
 
  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0 
 
  junk   = { CW_PDMENU_S, flags:0, name:'' } 
 
IF NOT KEYWORD_SET(QUAKE_TIME_BORDER) THEN BEGIN 
   minjs=MIN(quake_js,MAX=maxjs) 
   js2ymds,minjs,from_Y,from_M,from_D,Offset_s 
   sec2hms,Offset_s,from_hour,from_Min,from_sec 
   js2ymds,maxjs,to_Y,to_M,to_D,Offset_s 
   sec2hms,Offset_s,to_hour,to_Min,to_sec 
   quake_time_border=DBLARR(2) 
   quake_time_border(0)=minjs 
   quake_time_border(1)=maxjs 
ENDIF ELSE BEGIN 
   js2ymds,quake_time_border(0),from_Y,from_M,from_D,Offset_s 
   sec2hms,Offset_s,from_hour,from_Min,from_sec 
   js2ymds,quake_time_border(1),to_Y,to_M,to_D,Offset_s 
   sec2hms,Offset_s,to_hour,to_Min,to_sec 
ENDELSE 
 
 
quake_time_border_old=quake_time_border 
 
  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $ 
      COLUMN=1, $ 
      MAP=1, $ 
      TITLE='Edit time', $ 
      UVALUE='MAIN13') 
 
  BASE155 = WIDGET_BASE(MAIN13, $ 
      COLUMN=1, $ 
      FRAME=1, $ 
      MAP=1, $ 
      TITLE='BASE_DATE', $ 
      UVALUE='BASE155') 
 
  LABEL388 = WIDGET_LABEL( BASE155, $ 
      UVALUE='LABEL388', $ 
      VALUE='Date, Time :') 
 
  BASE404 = WIDGET_BASE(BASE155, $ 
      ROW=1, $ 
      MAP=1, $ 
      UVALUE='BASE404') 
 
  LABEL410 = WIDGET_LABEL( BASE404, $ 
      UVALUE='LABEL410', $ 
      VALUE='Day', $ 
      XSIZE=60) 
 
  FieldVal3772 = [ $ 
    '' ] 
  FIELD_FROM_DAY = CW_FIELD( BASE404,VALUE=FieldVal3772, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='min', $ 
      UVALUE='FIELD_FROM_DAY', $ 
      XSIZE=3) 
 
  FieldVal3774 = [ $ 
    '' ] 
  FIELD_TO_DAY = CW_FIELD( BASE404,VALUE=FieldVal3774, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='max', $ 
      UVALUE='FIELD_TO_DAY', $ 
      XSIZE=3) 
 
 
  BASE453 = WIDGET_BASE(BASE155, $ 
      ROW=1, $ 
      MAP=1, $ 
      UVALUE='BASE453') 
 
  LABEL450 = WIDGET_LABEL( BASE453, $ 
      UVALUE='LABEL450', $ 
      VALUE='Month', $ 
      XSIZE=60) 
 
  FieldVal3940 = [ $ 
    '' ] 
  FIELD_FROM_MONTH = CW_FIELD( BASE453,VALUE=FieldVal3940, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='min', $ 
      UVALUE='FIELD_FROM_MONTH', $ 
      XSIZE=3) 
 
  FieldVal3942 = [ $ 
    '' ] 
  FIELD_TO_MONTH = CW_FIELD( BASE453,VALUE=FieldVal3942, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='max', $ 
      UVALUE='FIELD_TO_MONTH', $ 
      XSIZE=3) 
 
 
  BASE457 = WIDGET_BASE(BASE155, $ 
      ROW=1, $ 
      MAP=1, $ 
      UVALUE='BASE457') 
 
  LABEL454 = WIDGET_LABEL( BASE457, $ 
      UVALUE='LABEL454', $ 
      VALUE='Year', $ 
      XSIZE=60) 
 
  FieldVal3946 = [ $ 
    '' ] 
  FIELD_FROM_YEAR = CW_FIELD( BASE457,VALUE=FieldVal3946, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='min', $ 
      UVALUE='FIELD_FROM_YEAR', $ 
      XSIZE=6) 
 
  FieldVal3948 = [ $ 
    '' ] 
  FIELD_TO_YEAR = CW_FIELD( BASE457,VALUE=FieldVal3948, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='max', $ 
      UVALUE='FIELD_TO_YEAR', $ 
      XSIZE=6) 
 
 
  BASE417 = WIDGET_BASE(BASE155, $ 
      ROW=1, $ 
      MAP=1, $ 
      UVALUE='BASE417') 
 
  LABEL435 = WIDGET_LABEL( BASE417, $ 
      UVALUE='LABEL435', $ 
      VALUE='Hour', $ 
      XSIZE=60) 
 
  FieldVal3778 = [ $ 
    '' ] 
  FIELD_FROM_HOUR = CW_FIELD( BASE417,VALUE=FieldVal3778, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='min', $ 
      UVALUE='FIELD_FROM_HOUR', $ 
      XSIZE=3) 
 
  FieldVal3780 = [ $ 
    '' ] 
  FIELD_TO_HOUR = CW_FIELD( BASE417,VALUE=FieldVal3780, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='max', $ 
      UVALUE='FIELD_TO_HOUR', $ 
      XSIZE=3) 
 
 
  BASE418 = WIDGET_BASE(BASE155, $ 
      ROW=1, $ 
      MAP=1, $ 
      UVALUE='BASE418') 
 
  LABEL437 = WIDGET_LABEL( BASE418, $ 
      UVALUE='LABEL437', $ 
      VALUE='Minute', $ 
      XSIZE=60) 
 
  FieldVal3784 = [ $ 
    '' ] 
  FIELD_FROM_MINUTE = CW_FIELD( BASE418,VALUE=FieldVal3784, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='min', $ 
      UVALUE='FIELD_FROM_MINUTE', $ 
      XSIZE=3) 
 
  FieldVal3786 = [ $ 
    '' ] 
  FIELD_TO_MINUTE = CW_FIELD( BASE418,VALUE=FieldVal3786, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='max', $ 
      UVALUE='FIELD_TO_MINUTE', $ 
      XSIZE=3) 
 
 
  BASE425 = WIDGET_BASE(BASE155, $ 
      ROW=1, $ 
      MAP=1, $ 
      UVALUE='BASE425') 
 
  LABEL439 = WIDGET_LABEL( BASE425, $ 
      UVALUE='LABEL439', $ 
      VALUE='Second', $ 
      XSIZE=60) 
 
  FieldVal3790 = [ $ 
    '' ] 
  FIELD_FROM_SEC = CW_FIELD( BASE425,VALUE=FieldVal3790, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='min', $ 
      UVALUE='FIELD_FROM_SEC', $ 
      XSIZE=3) 
 
  FieldVal3792 = [ $ 
    '' ] 
  FIELD_TO_SEC = CW_FIELD( BASE425,VALUE=FieldVal3792, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      TITLE='max', $ 
      UVALUE='FIELD_TO_SEC', $ 
      XSIZE=3) 
 
 
 
  LABEL256 = WIDGET_LABEL( MAIN13, $ 
      UVALUE='LABEL256', $ 
      VALUE='') 
 
  BUTTON37 = WIDGET_BUTTON( MAIN13, $ 
      UVALUE='BUTTON_CANCEL', $ 
      VALUE='Cancel') 
 
  BUTTON40 = WIDGET_BUTTON( MAIN13, $ 
      UVALUE='BUTTON_OK', $ 
      VALUE='Ok') 
 
   WIDGET_CONTROL,FIELD_FROM_DAY,SET_VALUE=from_D 
   WIDGET_CONTROL,FIELD_FROM_MONTH,SET_VALUE=from_M 
   WIDGET_CONTROL,FIELD_FROM_YEAR,SET_VALUE=from_Y 
   WIDGET_CONTROL,FIELD_FROM_HOUR,SET_VALUE=from_hour 
   WIDGET_CONTROL,FIELD_FROM_MINUTE,SET_VALUE=from_min 
   WIDGET_CONTROL,FIELD_FROM_SEC,SET_VALUE=from_sec 
   WIDGET_CONTROL,FIELD_TO_DAY,SET_VALUE=to_D 
   WIDGET_CONTROL,FIELD_TO_MONTH,SET_VALUE=to_M 
   WIDGET_CONTROL,FIELD_TO_YEAR,SET_VALUE=to_Y 
   WIDGET_CONTROL,FIELD_TO_HOUR,SET_VALUE=to_hour 
   WIDGET_CONTROL,FIELD_TO_MINUTE,SET_VALUE=to_min 
   WIDGET_CONTROL,FIELD_TO_SEC,SET_VALUE=to_sec 
 
  WIDGET_CONTROL, MAIN13, /REALIZE 
 
 
Ev='' 
 
WHILE (Ev NE 'BUTTON_OK') AND (Ev NE 'BUTTON_CANCEL') DO BEGIN 
 
Event=WIDGET_EVENT(MAIN13) 
 
WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev 
 
CASE Ev OF 
 
  'BUTTON_CANCEL': BEGIN 
      END 
  'BUTTON_OK': BEGIN 
      END 
 
ENDCASE 
 
ENDWHILE 
 
IF Ev EQ 'BUTTON_OK' THEN BEGIN 
 
create_structure: 
 
   WIDGET_CONTROL,FIELD_FROM_DAY,GET_VALUE=from_D 
   WIDGET_CONTROL,FIELD_FROM_MONTH,GET_VALUE=from_M 
   WIDGET_CONTROL,FIELD_FROM_YEAR,GET_VALUE=from_Y 
   WIDGET_CONTROL,FIELD_FROM_HOUR,GET_VALUE=from_hour 
   WIDGET_CONTROL,FIELD_FROM_MINUTE,GET_VALUE=from_min 
   WIDGET_CONTROL,FIELD_FROM_SEC,GET_VALUE=from_sec 
   WIDGET_CONTROL,FIELD_TO_DAY,GET_VALUE=to_D 
   WIDGET_CONTROL,FIELD_TO_MONTH,GET_VALUE=to_M 
   WIDGET_CONTROL,FIELD_TO_YEAR,GET_VALUE=to_Y 
   WIDGET_CONTROL,FIELD_TO_HOUR,GET_VALUE=to_hour 
   WIDGET_CONTROL,FIELD_TO_MINUTE,GET_VALUE=to_min 
   WIDGET_CONTROL,FIELD_TO_SEC,GET_VALUE=to_sec 
 
   quake_time_border(0)=YMDS2JS(from_Y, $ 
                   from_M, $ 
                   from_D, $ 
                   from_hour*3600.+from_min*60.+from_sec) 
 
   quake_time_border(1)=YMDS2JS(to_Y, $ 
                 to_M, $ 
                 to_D, $ 
                 to_hour*3600.+to_min*60.+to_sec) 
 
  IF (quake_time_border(0) NE quake_time_border_old(0)) OR $ 
     (quake_time_border(1) NE quake_time_border_old(1)) $ 
  THEN altered=1 ELSE altered=0 
 
ENDIF ELSE altered=0 
 
WIDGET_CONTROL,MAIN13,/DEST 
 
END 
