;-------------------------------------------------------------
;+
; NAME:
;       FEXT
; PURPOSE:
;       Returnes string containing extension of input filename-string
; CATEGORY:
;       String-processing
; CALLING SEQUENCE:
;       result = FEXT(filename)
; INPUTS:
;       filename = String containing the full filename
; KEYWORD PARAMETERS:
;       NOPOINT = Return without leading point
; OUTPUTS:
;       result = String containing the extension as defined by the last substring of ;       'filename' divided by '.')
; COMMON BLOCKS:
; NOTES:
;       returns -1, if filename contains no extension
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TU-Darmstadt, Germany, 12 April, 1997
;
;       No warranty that this program is free of error
;
;-
;-------------------------------------------------------------
FUNCTION FEXT,file,NOPOINT=NOPOINT

IF STRPOS(file,'.') EQ -1 THEN RETURN,-1 $               ; Point was not found -> no extension
ELSE BEGIN
seperated=STR_SEP(file,'.')
nstrings=N_ELEMENTS(seperated)
IF KEYWORD_SET(NOPOINT) THEN $
   RETURN, seperated(nstrings-1) $                           ; Return with string containing file extension
ELSE RETURN, '.'+seperated(nstrings-1)
ENDELSE
END
