;-------------------------------------------------------------
;+
; NAME:
;       MAINSHCK
; PURPOSE:
;       Mainshock information / selection program
; MAIN PROGRAM:
;       SLAP - program for testing SEISMOLAP 
;       SEISMOLAP was developed by Jochen Zschau,
;       Geoforschungszentrum Potsdam, Germany
; DEPENDENCIES:
;       GRIDAREA.PRO
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TU-Darmstadt, Germany, 17 Apr, 1998.
;       No warranty that this program is free of error
;-
;-------------------------------------------------------------
PRO MAINSHCK, GROUP=Group,$
            ALTERED=altered,$
            QUAKE_LON=quake_lon,$
            QUAKE_LAT=quake_lat,$
            QUAKE_Z=quake_z,$
            QUAKE_STRENGTH=quake_strength,$
            QUAKE_JS=quake_js,$
            INFO_SHOCK=info_shock,$
            SHOCKINFOTEXT=shockinfotext,$
            SUPRESS_SWITCH=SUPRESS_SWITCH,$
            SELECTED_SCHOCK=selected_shock,$
            FOCUS=focus

  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  focus = 0

  mainshocks = 1

  junk   = { CW_PDMENU_S, flags:0, name:'' }


  MAIN1 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Main Events', $
      UVALUE='MAIN1')


  FIELD_MAIN_EVENTS = CW_FIELD( MAIN1,VALUE=mainshocks, $
      ROW=1, $
      INT=1, $
      ALL_EVENTS=1, $
      TITLE='Number of events:', $
      UVALUE='FIELD_MAIN_EVENTS', $
      XSIZE=9)

  BUTTON37 = WIDGET_BUTTON( MAIN1, $
      UVALUE='SHOW', $
      VALUE='Show')

  LABEL1=WIDGET_LABEL(MAIN1,$
         VALUE='')

  BUTTON37 = WIDGET_BUTTON( MAIN1, $
      UVALUE='BUTTON_CANCEL', $
      VALUE='Cancel')

  BUTTON40 = WIDGET_BUTTON( MAIN1, $
      UVALUE='BUTTON_OK', $
      VALUE='Ok')

  WIDGET_CONTROL, MAIN1, /REALIZE

Ev=''

WHILE (Ev NE 'BUTTON_OK') AND (Ev NE 'BUTTON_CANCEL') DO BEGIN

Event=WIDGET_EVENT(MAIN1)

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF

  'FIELD_MAIN_EVENTS': BEGIN
      WIDGET_CONTROL,FIELD_MAIN_EVENTS,GET_VALUE=mainshocks
      END

  'SHOW': BEGIN
      answ=GRIDAREA(quake_lon,$
                    quake_lat,$
                    QUAKE_Z=quake_z,$
                    QUAKE_STRENGTH=quake_strength,$
                    QUAKE_JS=quake_js,$
                    INFO_SHOCK=info_shock,$
                    SELECTED_SCHOCK=selected_shock,$
                    SHOCKINFOTEXT=shockinfotext,$
                    FOCUS=focus,$
                    MAINSHOCKS=mainshocks,$
                    SUPRESS_SWITCH=SUPRESS_SWITCH,$
                    /SUPRESS_SELECT,$
                    /SUPRESS_GRID )
      END
  'BUTTON_CANCEL': BEGIN
      END
  'BUTTON_OK': BEGIN
      END

  ENDCASE

ENDWHILE

IF Ev EQ 'BUTTON_OK' THEN BEGIN
   altered=1
ENDIF ELSE BEGIN     ;Cancel

      ;Setting flag
      focus=0
      altered=0
ENDELSE

IF DEFINED(MAIN1) THEN WIDGET_CONTROL,MAIN1,/DESTROY

END

