;-------------------------------------------------------------
;+
; NAME:
;       SCL
; PURPOSE:
;       Scales a vektor to given range
; CATEGORY:
;       Math
; CALLING SEQUENCE:
;       result=SCL([minimum],[maximum],[vektor])
; INPUTS:
;       minimum = lower value of range
;       maximum = upper value of range
;       vektor = contains to be transformed values
; KEYWORD PARAMETERS:
; OUTPUTS:
;       result = the values of [vektor] normalized to given range
; COMMON BLOCKS:
; NOTES:
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TH-Darmstadt, Germany, 20 November, 1997.
;
;-
;-------------------------------------------------------------
FUNCTION SCL,mini,maxi,vektor

new_vektor=double(vektor)
min_val=MIN(new_vektor,MAX=max_val)
new_vektor=TEMPORARY(new_vektor)-min_val
span_val=max_val-min_val
IF span_val NE 0 THEN BEGIN
   new_vektor=TEMPORARY(new_vektor)/span_val * (maxi-mini) + mini
   RETURN,TEMPORARY(new_vektor)
ENDIF ELSE RETURN,-1
END
