;-------------------------------------------------------------
;+
; NAME:
;       SHOCKINFO
; PURPOSE:
;       Pops up an window with earthquake-information
; MAIN PROGRAM:
;       SLAP - program for testing SEISMOLAP
;       SEISMOLAP was developed by Jochen Zschau,
;       Geoforschungszentrum Potsdam, Germany
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TH-Darmstadt, Germany, 17. Apr 1998 .
;
;       No warranty that this program is free of error
;-
;-------------------------------------------------------------
PRO SHOCKINFO, info, $
               index, $
               FOCUS=focus, $
               SUPRESS_SWITCH=SUPRESS_SWITCH,$
               SHOCKINFOTEXT=shockinfotext

  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  focus=0

  IF NOT KEYWORD_SET(INFOSHOCKTEXT) THEN shockinfotext= 'Spatial focus on this event'

  MAIN1 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Info', $
      UVALUE='MAIN1')

  FIELD_MAGNITUDE = CW_FIELD( MAIN1,VALUE=info.mag(index), $
      ROW=1, $
      FLOAT=1, $
      TITLE='Magnitude', $
      XSIZE=9, $
      /NOEDIT)

  FIELD_LONGITUDE = CW_FIELD( MAIN1,VALUE=info.lon(index), $
      ROW=1, $
      FLOAT=1, $
      TITLE='Longitude', $
      XSIZE=9, $
      /NOEDIT)

  FIELD_LATITUDE = CW_FIELD( MAIN1,VALUE=info.lat(index), $
      ROW=1, $
      FLOAT=1, $
      TITLE='Latitude', $
      XSIZE=9, $
      /NOEDIT)

  FIELD_DEPTH = CW_FIELD( MAIN1,VALUE=info.z(index), $
      ROW=1, $
      FLOAT=1, $
      TITLE='Depth', $
      XSIZE=9, $
      /NOEDIT)

      dt_tm_brk,dt_tm_fromjs(info.js(index),FORMAT='0d$.n$.Y$ h$:m$:s$'),date,time

  FIELD_DATE = CW_FIELD( MAIN1,VALUE=date, $
      ROW=1, $
      STRING=1, $
      TITLE='Date', $
      XSIZE=15, $
      /NOEDIT)

  FIELD_TIME = CW_FIELD( MAIN1,VALUE=time, $
      ROW=1, $
      STRING=1, $
      TITLE='Time', $
      XSIZE=15, $
      /NOEDIT)

  IF NOT KEYWORD_SET(SUPRESS_SWITCH) THEN BEGIN

     Btns5191 = [ shockinfotext ]
     BGROUP_FOCUS = CW_BGROUP( MAIN1, Btns5191, $
        COLUMN=1, $
        NONEXCLUSIVE=1, $
        UVALUE='BGROUP_FOCUS')
   ENDIF

  BUTTON40 = WIDGET_BUTTON( MAIN1, $
      UVALUE='BUTTON_OK', $
      VALUE='Ok')

  WIDGET_CONTROL, MAIN1, /REALIZE

Ev=''

WHILE (Ev NE 'BUTTON_OK') DO BEGIN

Event=WIDGET_EVENT(MAIN1)

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF

  'BGROUP_FOCUS': BEGIN
      focus = Event.Select
      END
  'BUTTON_OK': BEGIN
      END

  ENDCASE

ENDWHILE

IF Ev EQ 'BUTTON_OK' THEN BEGIN


   IF DEFINED(MAIN1) THEN WIDGET_CONTROL,MAIN1,/DESTROY

   RETURN

ENDIF

END


