;-------------------------------------------------------------
;+
; NAME:
;       WID_ALIVE
; PURPOSE:
;       Checks for validity of a widget specified with its id.
; CATEGORY:
;       Informational Routines
; CALLING SEQUENCE:
;       Result=wid_alive, id [,/destroy]
; INPUTS:
;       ID=Id of the examined widget
; KEYWORD PARAMETERS:
;       Keywords:
;       DESTROY=If the widget is alive, it is destroyed.
; OUTPUTS:
;       RESULT= Value is 1, if the widget is alive, else 0 is returned.
; COMMON BLOCKS:
; NOTES:
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TH-Darmstadt, Germany, 03 Apr, 1997
;-
;-------------------------------------------------------------

FUNCTION WID_ALIVE, id, DESTROY=destroy

    IF DEFINED(id) THEN BEGIN
     valid=WIDGET_INFO(id,/VALID_ID)               ; Look, if the WIDGET is alive
     IF KEYWORD_SET(DESTROY) THEN $
      IF valid THEN WIDGET_CONTROL,id,/DESTROY

     RETURN, valid
     ENDIF ELSE RETURN, 0                          ; id is not defined

 END