;-------------------------------------------------------------
;+
; NAME:
;       XOWRITE
; PURPOSE:
;       Pops up a window with a yes/no Question. The caller-programm is blocked,
;       until the yes or the no button is pressed.
; CATEGORY:
;       Widgets
; CALLING SEQUENCE:
;       answer=XOWRITE(file)
; INPUTS:
; KEYWORD PARAMETERS:
;       Keywords:
; OUTPUTS:
;       Returns string either 'N' for No or 'Y' for Yes.
; COMMON BLOCKS:
; DEPENDENCIES:
;       XDECISION
; MODIFICATION HISTORY:
;       Matthias Liebetanz, 01. Nov, 1997
;-
;-------------------------------------------------------------

FUNCTION XOWRITE, file

tmp=FINDFILE(file,COUNT=found)

IF found NE 0 THEN BEGIN

   answer=XDECISION([[file+' already exists.'],$
                     ['Do you want to overwrite it?']])

ENDIF ELSE answer='Y'

RETURN, answer

END
