;-------------------------------------------------------------
;+
; NAME:
;       XSAVE_IT
; PURPOSE:
;       Pops up a window with a yes/no Question. The caller-programm is blocked,
;       until the yes or the no button is pressed.
; CATEGORY:
;       Widgets
; CALLING SEQUENCE:
;       answer=XOWRITE(file)
; INPUTS:
; KEYWORD PARAMETERS:
;       Keywords:
; OUTPUTS:
;       Returns string either 'N' for No or 'Y' for Yes.
; COMMON BLOCKS:
; DEPENDENCIES:
;       XDECISION
; MODIFICATION HISTORY:
;       Matthias Liebetanz, 01. Nov, 1997
;-
;-------------------------------------------------------------

PRO XSAVE_IT, state, INITPATH=initpath, INITNAME=initname, EXT=ext, EXITPATH=exitpath, EXITNAME=exitname


     IF NOT KEYWORD_SET(INITPATH) THEN initpath=' '
     IF NOT KEYWORD_SET(INITNAME) THEN initname=' '
     IF KEYWORD_SET(EXT) THEN initname=initname+'.'+ext

     answer='N' & file=' '
     WHILE (answer EQ 'N') AND (file NE '') DO BEGIN
       file = PICKFILE(/WRITE, PATH=initpath, FILE=initname, GET_PATH=path)

       IF file NE '' THEN BEGIN

          answer=XOWRITE(file)
          IF answer NE 'N' THEN BEGIN
             SAVE,state,FILENAME=file
             exitpath=path
             exitname=FPRAEFIX(file)
          ENDIF ELSE BEGIN
             initpath=path
             initname=FPRAEFIX(file)
          ENDELSE
       ENDIF
     ENDWHILE

     END


