;-------------------------------------------------------------
;+
; NAME:
;       XSTAT
; PURPOSE:
;       User interface to show various histograms
; MAIN PROGRAM:
;       SLAP - program for testing SEISMOLAP
;       SEISMOLAP was developed by Jochen Zschau,
;       Geoforschungszentrum Potsdam, Germany
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TH-Darmstadt, Germany, 17. Apr 1998 .
;
;       No warranty that this program is free of error
;-
;-------------------------------------------------------------
PRO XSTAT, GROUP=Group,$
           QUAKE_MAG=quake_mag,$
           QUAKE_Z=quake_z,$
           QUAKE_JS=quake_js, $
           QUAKE_QUALITY=quake_quality

IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

P_saved = !P

magmin = MIN(quake_mag, MAX = magmax)
zmin = MIN(quake_z, MAX = zmax)
qualmin = MIN(quake_quality, MAX = qualmax)

  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Statistics', $
      UVALUE='MAIN13')

  LABEL189 = WIDGET_LABEL( MAIN13, $
      UVALUE='LABEL189', $
      VALUE='Histograms')

  BUTTON196 = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON_HIST_MAG', $
      VALUE='Events - Magnitude')

  BUTTON194 = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON_HIST_DEPTH', $
      VALUE='Events - Depth')

  BUTTON198 = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON_HIST_QUALITY', $
      VALUE='Events - Quality')

  LABEL168 = WIDGET_LABEL( MAIN13, $
      UVALUE='LABEL168', $
      VALUE='')

  BUTTON200 = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON_HIST_MORE', $
      VALUE='more..')

  LABEL168 = WIDGET_LABEL( MAIN13, $
      UVALUE='LABEL168', $
      VALUE='')

  BUTTON_OK = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON_OK', $
      VALUE='Ok')

  WIDGET_CONTROL, MAIN13, /REALIZE


Ev=''

WHILE (Ev NE 'BUTTON_OK') DO BEGIN

Event=WIDGET_EVENT(MAIN13)

WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

CASE Ev OF

  'BUTTON_MAIN_EVENTS': BEGIN
      END
  'BUTTON_HIST_MAG': BEGIN
      WINDOW
      PLOT, HISTOGRAM(quake_mag,MIN=magmin,MAX=magmax), TITLE = 'Histogram - Magnitude', PSYM=10
      END
  'BUTTON_HIST_DEPTH': BEGIN
      WINDOW
      PLOT, HISTOGRAM(quake_z,MIN=zmin,MAX=zmax), TITLE = 'Histogram - Depth', PSYM=10
      END
  'BUTTON_HIST_QUALITY': BEGIN
      WINDOW
      PLOT, HISTOGRAM(quake_quality,MIN=qualmin,MAX=qualmax), TITLE = 'Histogram - Quality factor', PSYM=10
      END
  'BUTTON_HIST_MORE': BEGIN
      MOREHIST, MAGMIN = magmin, $
                MAGMAX = magmax, $
                ZMIN = zmin, $
                ZMAX = zmax,$
                QUALMIN = qualmin, $
                QUALMAX = qualmax
      END
  'BUTTON_OK': BEGIN
      END

ENDCASE

ENDWHILE

IF Ev EQ 'BUTTON_OK' THEN BEGIN


IF DEFINED(MAIN13) THEN WIDGET_CONTROL,MAIN13,/DESTROY
IF !D.WINDOW GE 0 THEN WDELETE, !D.WINDOW


ENDIF

!P = P_saved

RETURN

END

