;-------------------------------------------------------------
;+
; NAME:
;       TRUNCATOR
; PURPOSE:
;       Truncates long filenames (for IDL 4.0 for Windows and lower versions).
; CATEGORY:
;       Misc
; CALLING SEQUENCE:
;       truncator
; INPUTS:
; KEYWORD PARAMETERS:
; OUTPUTS:
; COMMON BLOCKS:
; NOTES:
;       Works only with IDL 4.0 for Windows or higher or other platforms
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TH-Darmstadt, Germany, 04 Apr, 1997
;-
;-------------------------------------------------------------



PRO PDMENU2_Event, Event


  CASE Event.Value OF


  'File.Open': BEGIN
    PRINT, 'Event for File.Open'

    state_holder = WIDGET_INFO( event.handler, /CHILD )
    WIDGET_CONTROL, state_holder, GET_UVALUE=state,/NO_COPY             ; Get the state

     IF DEFINED(state,TAG='PATH',/STRUCTURE) THEN path=state.path ELSE path=''
     i_Dir=0
     Filename=' '
     WHILE FileName NE '' DO BEGIN

      FileName = PICKFILE(/READ, GROUP=event.top,             $
                           TITLE='Choose one File of '+STRTRIM(STRING(i_Dir+1),1)+'. Dir', $
                           FILTER='*.pro', $
                           PATH=path,$
                           GET_PATH=path)
      IF FileName EQ '' THEN GOTO, _ENDWHILE
      i_Dir=i_Dir+1
      WIDGET_CONTROL,/HOURGLASS

      tmp = FINDFILE(path+'*.pro',COUNT=n_tmp)
      length = STRLEN(path)
      tmp = STRMID(tmp,length,20)

      IF N_ELEMENTS(oldnames) NE 0 THEN BEGIN

       oldnames= [TEMPORARY(oldnames),TEMPORARY(tmp)]                      ; Adding new filenames
       n_oldnames=n_oldnames+n_tmp
       paths=[paths,path]
       lastpath=path
       ENDIF ELSE BEGIN
       oldnames= TEMPORARY(tmp)                                       ; Initialize oldnames with tmp
       n_oldnames=n_tmp                                               ; Initialize n_oldnames with n_tmp
       paths=path
       lastpath=path
       ENDELSE
      _ENDWHILE:                                                  ; Label for abortion of WHILE
     ENDWHILE

      IF N_ELEMENTS(oldnames) EQ 0 THEN GOTO, _END_File_Open            ; Cancel 'File.Open.File'

      state = CREATE_STRUCT('oldnames',TEMPORARY(oldnames), $              ; 'oldnames' :original filenames
                            'n_oldnames',n_oldnames,$
                            'i_dir',i_Dir,$
                            'paths',paths,$
                            'path',lastpath)

      state_holder = WIDGET_INFO( event.handler, /CHILD )

    _END_File_Open:
    WIDGET_CONTROL, state_holder, SET_UVALUE=state,/NO_COPY           ;  Store the names in state
    END
  'File.Close': BEGIN
    PRINT, 'Event for File.Close'
    state=''
    state_holder = WIDGET_INFO( event.handler, /CHILD )          ; Reset state
    WIDGET_CONTROL, state_holder, SET_UVALUE=state,/NO_COPY
   END
  'File.Save batchfile': BEGIN
    PRINT, 'Event for File.Save batchfile'
      state_holder = WIDGET_INFO( event.handler, /CHILD )
      WIDGET_CONTROL, state_holder, GET_UVALUE=state,/NO_COPY             ; Get the state
      def_state=DEFINED(state, /STRUCTURE)
      def_state_newnames=DEFINED(state, TAG='NEWNAMES', /STRUCTURE)

      IF def_state EQ 0 THEN BEGIN                                          ; If it is not a structure
       mssg=WIDGET_MESSAGE('No file open. Open File first.',/INFORMATION,TITLE='Truncator')
       GOTO, _End_File_Save                                                 ; CANCEL 'File.Save File as..'
      ENDIF ELSE $
       IF def_state_newnames EQ 0 THEN BEGIN                                  ; If it is a structure without tag: 'newnames'
        mssg=WIDGET_MESSAGE('Please truncate Filenames first.',/INFORMATION,TITLE='Truncator')
        GOTO, _End_File_Save                                                ; CANCEL '_End_File_Save'
        ENDIF

      FileName = PICKFILE(/WRITE,          $
                          TITLE='Create a batch-file', $
                          FILTER='*.bat',  $
                          PATH=state.path,$
                          GET_PATH=path)
      IF FileName EQ '' THEN GOTO, _End_File_Save                    ; CANCEL '_End_File_Save'
      state.path=path                                                  ; Update path
      TextBatch = ['REM Truncator for Windows, Vers. 1.0', $
                   'REM Matthias Liebetanz, TH-Darmstadt, Germany', $
                   'REM', $
                   'REM File created: '+SYSTIME(), $
                   'REM examined: '+STRING(state.n_oldnames), $
                   'REM renamed: '+STRING(state.n_renamed), $
                   'REM equal: '+STRING(state.n_equal)]
      IF state.n_equal NE 0 THEN $
      TextBatch = [TextBatch, $
                   'REM '+state.oldnames(state.equal_index)+'  -->  '+state.newnames(state.equal_index)]
      TextBatch = [TextBatch, $
                   'REM', $
                   'rename '+state.oldnames(state.new_index)+' '+state.newnames(state.new_index)]

      OPENW, unit, FILENAME, /GET_LUN                            ; open the file for writing
      PRINTF, unit, FORMAT='(A)',TextBatch
      FREE_LUN, unit


      answer=XDECISION([['Do you want also to save the batch file'],['in all examined paths?']])
      IF answer EQ 'Y' THEN BEGIN
         FOR i=0,state.i_dir-1 DO BEGIN
             holder=TextBatch
             SREPLACE,TextBatch,'rename ','rename '+state.paths(i)
             GET_LUN,unit
             OPENW, unit, state.paths(i)+FPRAEFIX(filename,/NO_PATH)+FEXT(filename)                             ; open the file for writing
             PRINTF, unit, FORMAT='(A)',TextBatch
             FREE_LUN, unit
             TextBatch=TEMPORARY(holder)
         ENDFOR
      ENDIF

      IF DEFINED(state,TAG='BATCHFILE',/STRUCTURE)  THEN BEGIN
         state.batchfile=FILENAME
         state.allpathssaved=answer
      ENDIF ELSE $
         state=CREATE_STRUCT(state,$                             ; adding new TAG
                             'batchfile',filename,$
                             'allpathssaved',answer)
_End_File_Save:
      WIDGET_CONTROL, state_holder, SET_UVALUE=state,/NO_COPY     ; store the state
    END
  'File.View batchfile': BEGIN
    PRINT, 'Event for File.View batchfile'

      state_holder = WIDGET_INFO( event.handler, /CHILD )
      WIDGET_CONTROL, state_holder, GET_UVALUE=state,/NO_COPY             ; Get the state

      IF DEFINED(state,/STRUCTURE) THEN lastpath=state.path ELSE BEGIN
         state=CREATE_STRUCT('path','')                                   ; Create struct for path-info
         path=''
      ENDELSE
      FileName = PICKFILE(/READ, GROUP=event.top, $
                           TITLE='Choose batch-file', $
                           FILTER='*.bat', $
                           PATH=state.path,$
                           GET_PATH=path)
      IF FileName NE '' THEN BEGIN
         WIDGET_CONTROL,/HOURGLASS
         XDISPLAYFILE, FileName, GROUP=event.top
         state.path=path
      ENDIF

      WIDGET_CONTROL, state_holder, SET_UVALUE=state, /NO_COPY             ; store the state

   END

  'File.Exit': BEGIN
    PRINT, 'Event for File.Exit'
       WIDGET_CONTROL, Event.Top,  /DESTROY                       ; Destroy application
       XMANAGER
   END
  'Renaming.Truncate Filenames': BEGIN
    PRINT, 'Event for Renaming.Truncate Filenames'

      state_holder = WIDGET_INFO( event.handler, /CHILD )
      WIDGET_CONTROL, state_holder, GET_UVALUE=state,/NO_COPY    ; Get the state

      def_state=DEFINED(state,TAG='OLDNAMES',/STRUCTURE)

      IF def_state EQ 0 THEN BEGIN                               ; If it is not a structure
        mssg=WIDGET_MESSAGE('No file open. Open File first.',$
                            /INFORMATION,TITLE='Truncator')
        GOTO, _End_Truncate                                       ; CANCEL 'File.Save File as..'
      ENDIF

      WIDGET_CONTROL,/HOURGLASS

      newnames = state.oldnames                                  ; initialize 'newnames':holder of filenames without extension '.pro'

      SREPLACE,newnames,'.pro','',/UPCASE                          ; Get rid of the extensions

      length=STRLEN( newnames)
      new_index=WHERE( length GT 8,count)                        ; don't forget the positions of long filenames: 'new_index'

      IF count EQ 0 THEN $
       mssg=WIDGET_MESSAGE('There are no long filenames',/INFORMATION,TITLE='Truncator') $
      ELSE BEGIN


      count=1                                                    ; Assumption: there are long filenames
      WHILE count NE 0 DO BEGIN                                  ; IF count=0 -> all strings truncated to 8 digits

       length=STRLEN( newnames)
       index=WHERE( length GT 8,count)                           ; Find index of long filenames (>8 Letters)
       FOR i=0,count-1 DO BEGIN                                  ; FOR :Truncate filenames longer than 8 digits

        newnames(index(i))= STRTRUNC(newnames(index(i)) , length(index(i)) , 1)
        i=i+1                                                    ; Truncate string (length=length-1)
       ENDFOR
      ENDWHILE


       n_newnames=N_ELEMENTS( newnames)
       n=0                                                       ; Index of current equal filename
       FOR i=0, n_newnames-1 DO BEGIN                            ; FOR : search and change equal filenames
        cur_index=WHERE(newnames EQ newnames(i),count)           ; Is there one equal filename?
        IF count GE 2 THEN BEGIN                                 ; Yes!
         FOR j=0,count-2 DO BEGIN
          IF cur_index(j) NE i THEN BEGIN                        ; Do not change the wrong string
           IF N_ELEMENTS(equal_index) NE 0 THEN $                ; 'equal_index':Index of all equal filenames
            equal_index = [equal_index,cur_index(j)]             ; Add new index to old index

           n=n+1                                                 ; Increase number of equal element
           IF n LE 9 THEN digits=3 $
            ELSE IF (n GT 9) AND (n LE 99) THEN digits=4 $
                                           ELSE digits=5

           tmp=newnames(cur_index(j))

           STRPUT, tmp,        $                                 ; Change equal string to '*__1', '*__2' ... '*__<n>'
                   '__' + STRTRIM(STRING(n),2), $
                   length(cur_index(j)) - digits

           newnames(cur_index(j))=tmp

           IF N_ELEMENTS(equal_index) EQ 0 THEN $                ; 'equal_index':Index of all equal filenames
            equal_index = cur_index(j)                           ; initialize equal_index
           ENDIF
          ENDFOR
         ENDIF
        ENDFOR


      n_equal=N_ELEMENTS(equal_index)
      IF n_equal NE 0 THEN BEGIN                                 ; IF there are equal filenames
       new_index=[TEMPORARY(new_index),equal_index]              ; Append equal_index to new_index
       new_index=TEMPORARY(new_index(UNIQ(new_index,SORT(new_index))))      ; Extract the sorted, unique values
      ENDIF



      def_state_truncate=DEFINED(state, TAG='TRUNCATE', /STRUCTURE)    ; Defined, if 'Renaming.Truncate Filenames' was already done

      IF def_state_truncate EQ 0 THEN BEGIN                      ; If it is a structure without tag: 'newnames'

       state = CREATE_STRUCT( TEMPORARY(state), $
                            'newnames',TEMPORARY( newnames+'.pro'), $     ; adding tag 'newnames' = newnamenewnames filenames to state
                            'n_newnames',N_ELEMENTS(newnames)  , $     ; 'n_newnames' :number of renamed filenames
                            'new_index',new_index, $
                            'n_renamed',N_ELEMENTS(new_index), $
                            'n_equal', n_equal, $                ; 'n_equal' :number of equal filenames after first truncation
                            'truncate', 1 )                      ; 'Renaming.Truncate Filenames' is already done
       IF n_equal NE 0 THEN $
        state = CREATE_STRUCT( TEMPORARY(state), $
                            'equal_index',equal_index )          ; Index of all equal filenames

      ENDIF

      IF n_equal NE 0 THEN $
       mssg=WIDGET_MESSAGE(STRING(state.n_equal)+' equal filenames detected. Please see results.', $
                           TITLE='Truncator',  $
                           /INFORMATION) $

       ELSE $
       mssg=WIDGET_MESSAGE('Names truncated. Use "Save batchfile" for creating a batchfile.', $
                           TITLE='Truncator', $
                           /INFORMATION)



    ENDELSE

    _END_Truncate:
    WIDGET_CONTROL, state_holder, SET_UVALUE=state,/NO_COPY             ; store the state
    END
  'Renaming.Execute batchfile': BEGIN
    PRINT, 'Event for Renaming.Execute batchfile'
    state_holder = WIDGET_INFO( event.handler, /CHILD )
    WIDGET_CONTROL, state_holder, GET_UVALUE=state,/NO_COPY             ; Get the state
    IF DEFINED(state,TAG='BATCHFILE',/STRUCTURE) THEN BEGIN
       print,state.allpathssaved
       IF state.allpathssaved EQ 'Y' THEN BEGIN
          answer=XDECISION([['Do you want to execute all batchfiles'],['you just saved?']])
          IF answer EQ 'Y' THEN BEGIN
             answer=XDECISION([['This will change files on your harddisk!'],['Do you want to continue?']])
             IF answer EQ 'Y' THEN BEGIN
                FOR i=0,state.i_dir-1 DO BEGIN
                print,'Executing '+state.paths(i)+FPRAEFIX(state.batchfile,/NO_PATH)+FEXT(state.batchfile)+'..'
                SPAWN,state.paths(i)+FPRAEFIX(state.batchfile,/NO_PATH)
                ENDFOR
             ENDIF
          ENDIF ELSE BEGIN
             batchfile=' '
             path=state.path
             WHILE batchfile NE '' DO BEGIN
                   batchfile = PICKFILE(GROUP=event.top,$
                                        TITLE='Choose batchfile',$
                                        FILTER='*.bat',$
                                        PATH=path,$
                                        GET_PATH=path)
                   IF batchfile NE '' THEN BEGIN
                      answer=XDECISION([['This will change files on your harddisk!'],['Do you want to continue?']])
                      IF answer EQ 'Y' THEN BEGIN
                         print,'Executing '+batchfile+'..'
                         SPAWN,batchfile,result
                      ENDIF
                   ENDIF
              ENDWHILE
          ENDELSE
       ENDIF ELSE BEGIN
           batchfile=' '
           path=state.path
           WHILE batchfile NE '' DO BEGIN
                 batchfile = PICKFILE(GROUP=event.top,$
                                      TITLE='Choose batchfile',$
                                      FILTER='*.bat',$
                                      PATH=path,$
                                      GET_PATH=path)
                 IF batchfile NE '' THEN BEGIN
                    answer=XDECISION([['This will change files on your harddisk!'],['Do you want to continue?']])
                    IF answer EQ 'Y' THEN BEGIN
                       print,'Executing '+batchfile+'..'
                       SPAWN,batchfile,result
                    ENDIF
                 ENDIF
           ENDWHILE
       ENDELSE
    ENDIF ELSE BEGIN
        batchfile=' '

        IF DEFINED(state,/STRUCTURE) THEN $
           path=state.path $
        ELSE $
           state=CREATE_STRUCT('path','')
        WHILE batchfile NE '' DO BEGIN
              batchfile = PICKFILE(GROUP=event.top,$
                                   TITLE='Choose batchfile',$
                                   FILTER='*.bat',$
                                   PATH=state.path,$
                                   GET_PATH=path)
              IF batchfile NE '' THEN BEGIN
                 state.path=path                                     ; Update path-info
                 answer=XDECISION([['This will change files on your harddisk!'],['Do you want to continue?']])
                 IF answer EQ 'Y' THEN BEGIN
                    print,'Executing '+batchfile+'..'
                    SPAWN,batchfile,result
                 ENDIF
              ENDIF
        ENDWHILE
   ENDELSE

  WIDGET_CONTROL, state_holder, SET_UVALUE=state,/NO_COPY             ; store the state

  END
  'Renaming.Search and replace in files': BEGIN
    PRINT, 'Event for Renaming.Search and replace in files'

    state_holder = WIDGET_INFO( event.handler, /CHILD )
    WIDGET_CONTROL, state_holder, GET_UVALUE=statev                  ; Get the state
    IF DEFINED(state,/STRUCTURE) THEN $
      path=state.path $
    ELSE $
      state=CREATE_STRUCT('path','')

    i_Dir=1
    FileName = PICKFILE(/READ, GROUP=event.top,             $
                         TITLE='Choose BATCH-File', $
                         FILTER='*.bat', $
                         PATH=state.path,  $
                         GET_PATH=path)

      IF FileName EQ '' THEN  GOTO, _End_Search ELSE BEGIN

       state.path=path                                            ; Update path-info
       OPENR, UNIT, FILENAME, /GET_LUN, ERROR=i	                  ; open the file

       IF i lt 0 THEN BEGIN						                  ; OK?
	    mssg = WIDGET_MESSAGE( STRING(!err_string) + ' Can not read ' + filename, /ERROR)  ;NO
        ENDIF ELSE BEGIN

        check=''
        READF,UNIT, check, $
                     FORMAT='(6(/),10x,A)'

        IF FIX(check) EQ 0 THEN BEGIN
         FREE_LUN, UNIT
         mssg=WIDGET_MESSAGE('There are no equal filenames in this file',/INFORMATION)
         GOTO,_End_Search

         ENDIF ELSE BEGIN

         WHILE NOT EOF(UNIT)  DO BEGIN
          tmp=''
          READF,UNIT, tmp, $
                      FORMAT='(A)'

          IF STRPOS(tmp,'REM ') EQ -1  THEN  GOTO, _next1  ELSE BEGIN

           STRPUT,tmp,'   ',0
           tmp=STR_SEP(tmp,'-->')
           tmp=STRTRIM(tmp,2)

           IF N_ELEMENTS(search) NE 0 THEN BEGIN
            search=[search,tmp(0)]  &  replace=[replace,tmp(1)]
            ENDIF ELSE BEGIN
            search=tmp(0)  &  replace=tmp(1)
            ENDELSE
           ENDELSE
          ENDWHILE
         ENDELSE
        ENDELSE
       ENDELSE
        _next1:
       FREE_LUN, UNIT




     Filename=' '
     WHILE FileName NE '' DO BEGIN
      FileName = PICKFILE(/READ, GROUP=event.top,             $
                           TITLE='Choose one file of directory to be examined', $
                           FILTER='*.pro', $
                           PATH=state.path,  $
                           GET_PATH=path)
      IF FileName EQ '' THEN GOTO, _End_Search
      state.path=path
      WIDGET_CONTROL,/HOURGLASS

      searchedfiles = FINDFILE(path+'*.pro',COUNT=n_searchedfiles)

      IF n_searchedfiles EQ 0 THEN GOTO,_End_Search            ; Cancel 'File.Search..'

      text=[['This will change files on your harddisk!'],['Do you want to continue?']]
      yn=XDECISION(text)

      IF yn EQ 'N' THEN GOTO, _End_Search $                         ; Terminated by user

       ELSE BEGIN

       SREPLACE,search,'.pro',''                             ; Delete extensions from search-strings
       SREPLACE,replace,'.pro',''

       tmp=''

       n_equal=N_ELEMENTS(search)

       progress=CW_PROGRESS(event.handler,TITLE='Search in files')       ; Calling CW_PROGRESS for Information about progress of searching

       tot_repl=0
       FOR i=0,n_searchedfiles-1 DO BEGIN
        current_file=searchedfiles(i)
        OPENR,UNIT,current_file,GET_LUN,ERROR=io_err
        IF io_err lt 0 THEN $                                            ; OK?
         mssg = WIDGET_MESSAGE( STRING(!err_string) + $                  ; NO
                ' Cannot open ' + current_file, /ERROR) $
         ELSE BEGIN
         file=''
         WHILE NOT EOF(UNIT)  DO BEGIN                                  ; Read the file in the variable 'file', its lines in 'temp'
          READF,UNIT, tmp, $
                      FORMAT='(A)'
          file=[file,tmp]
          ENDWHILE
          original=file

          SREPLACE,file,search,replace,/UPCASE,count,index

          IF count NE 0 THEN BEGIN                                      ; Search-String was found in file
           tot_repl=tot_repl+1                                          ; Count total number of replaced files
           FREE_LUN,UNIT
           old_file=current_file                                        ; initialize
           SREPLACE,old_file,'.pro','.old'                        ; Rename original file in *.old
           OPENW,UNIT,old_file,GET_LUN,ERROR=io_err
           IF io_err lt 0 THEN $                                        ; I/O OK?
            mssg = WIDGET_MESSAGE( STRING(!err_string) + $              ; NO
                   ' Cannot open ' + current_file, /ERROR) $
            ELSE PRINTF,UNIT,original(1:*), FORMAT='(A)'                ; Save original file as *.old
            FREE_LUN,UNIT
            OPENW,UNIT,current_file,GET_LUN,ERROR=io_err
            IF io_err lt 0 THEN $                                       ; I/O OK?
             mssg = WIDGET_MESSAGE( STRING(!err_string) + $             ; NO
                   ' Cannot open ' + current_file, /ERROR) $
            ELSE BEGIN
             PRINTF,UNIT,file(1:*), FORMAT='(A)'                        ; Save new file as *.pro
             ENDELSE
            FREE_LUN,UNIT
           ENDIF
          FREE_LUN,UNIT
         ENDELSE


         valid=WIDGET_INFO(progress,/VALID_ID)                           ; Look, if the CANCEL-button was pressed

         IF valid NE 0 THEN $
          WIDGET_CONTROL,progress, $                                     ; Update the information about progress
                         SET_VALUE=STRTRIM(STRING(i+1),1)+' of '+STRTRIM(STRING(n_searchedfiles),1)+' Files examined - '+STRTRIM(STRING(tot_repl),1)+' replaced.', $
                         /NO_COPY $

          ELSE GOTO, _End_Search                                        ; CW_PROGRESS is already destroyed

         event=WIDGET_EVENT(/nowait)                                    ; Look for arrived events and process them (f.e.CANCEL-Button)

        ENDFOR

      ENDELSE

      valid=WID_ALIVE(progress,/DESTROY)
      ENDWHILE


     _End_Search:

    valid=WID_ALIVE(progress,/DESTROY)

    END
  'Renaming.View results': BEGIN
    PRINT, 'Event for Renaming.View results'

      state_holder = WIDGET_INFO( event.handler, /CHILD )
      WIDGET_CONTROL, state_holder, GET_UVALUE=state,/NO_COPY             ; Get the state

      def_state=DEFINED(state, /STRUCTURE)
      def_state_newnames=DEFINED(state, TAG='NEWNAMES', /STRUCTURE)

      IF def_state EQ 0 THEN BEGIN                                          ; If it is not a structure
       mssg=WIDGET_MESSAGE('No file open. Open File first.',/INFORMATION,TITLE='Truncator')
       GOTO, _End_Show_Results                                   ; CANCEL 'File.Save File as..'
      ENDIF ELSE $
       IF def_state_newnames EQ 0 THEN BEGIN                     ; If it is a structure without tag: 'newnames'
        mssg=WIDGET_MESSAGE('Please truncate Filenames first.',/INFORMATION,TITLE='Truncator')
        GOTO, _End_Show_Results                                  ; CANCEL 'File.Save File as..'
        ENDIF

      Text = ['examined:'+STRING(state.n_oldnames),             $
              'renamed:'+STRING(state.n_renamed),         $
              'equal'+STRING(state.n_equal)]
      IF state.n_equal NE 0 THEN $                               ; If there are equal filenames
      Text = [Text,                                       $
              '',                                         $
              'Result equal:',                            $
              STRING(state.oldnames(state.equal_index) )+'  -->  '+ $
              STRING(state.newnames(state.equal_index) )]

      Text = [Text,                                       $
              '',                                         $
              'Result renamed:',                          $
              STRING(state.oldnames(state.new_index))+'  -->  '+ $
              STRING(state.newnames(state.new_index))]

      CW_ShowText,event.top,Text,TITLE='Results'


    _End_Show_Results:
    WIDGET_CONTROL, state_holder, SET_UVALUE=state,/NO_COPY             ; store the state

    END

  'Help.About Truncator for Windows..': BEGIN
    PRINT, 'Event for Help.About Truncator for Windows..'
    mssg=WIDGET_MESSAGE(['Author: Matthias Liebetanz, TH-Darmstadt, Germany.',$
                         'The Author makes no warranty that this program is free of error.'],$
                         /INFORMATION,TITLE='About Truncator for Windows, Vers 1.0')

    END
  ENDCASE
END


; DO NOT REMOVE THIS COMMENT: END PDMENU2
; CODE MODIFICATIONS MADE BELOW THIS COMMENT WILL BE LOST.








; CODE MODIFICATIONS MADE ABOVE THIS COMMENT WILL BE LOST.
; DO NOT REMOVE THIS COMMENT: BEGIN MAIN13

PRO MAIN13_Event, Event


  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF

  ; Event for PDMENU2
  'PDMENU2': PDMENU2_Event, Event
  ENDCASE
END


; DO NOT REMOVE THIS COMMENT: END MAIN13
; CODE MODIFICATIONS MADE BELOW THIS COMMENT WILL BE LOST.



PRO TRUNCATOR, GROUP=Group


  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }


  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $
      ROW=1, $
      MAP=1, $
      TITLE='Truncator', $
      UVALUE='MAIN13')


  BASE7 = WIDGET_BASE(MAIN13, $
      ROW=1, $
      MAP=1, $
      UVALUE='StateHolder')

  MenuDesc159 = [ $
      { CW_PDMENU_S,       1, 'File' }, $ ;        0
        { CW_PDMENU_S,       0, 'Open' }, $ ;        1
        { CW_PDMENU_S,       0, 'Close' }, $ ;        2
        { CW_PDMENU_S,       0, 'Save batchfile' }, $ ;        3
        { CW_PDMENU_S,       0, 'View batchfile' }, $ ;        4
        { CW_PDMENU_S,       2, 'Exit' }, $ ;        5
      { CW_PDMENU_S,       1, 'Renaming' }, $ ;        6
        { CW_PDMENU_S,       0, 'Truncate Filenames' }, $ ;        7
        { CW_PDMENU_S,       0, 'Execute batchfile' }, $ ;        8
        { CW_PDMENU_S,       0, 'Search and replace in files' }, $ ;        9
        { CW_PDMENU_S,       2, 'View results' }, $ ;        10
      { CW_PDMENU_S,       3, 'Help' }, $ ;        11
        { CW_PDMENU_S,       2, 'About Truncator for Windows..' } $  ;      12

  ]


  PDMENU2 = CW_PDMENU( MAIN13, MenuDesc159, /RETURN_FULL_NAME, $
      UVALUE='PDMENU2')

  WIDGET_CONTROL, MAIN13, /REALIZE

  XMANAGER, 'MAIN13', MAIN13
END



